#include<stdio.h>
#include<stdlib.h>

//Aqui é criada o struct junto com o Typedef. Assim não é preciso usar o comando typedef depois.
typedef struct celula{
    int dado;
    struct celula *proximo;
} celula;

void main()
{
    //criacão do inicio da lista. É sempre necessário ter este início.
    celula inicio;
    inicio.dado = 5; //Colocando um dado qualquer.
    inicio.proximo = NULL; // Apontando para NADA, pois esta é a primeira e a última célula.

    celula *novo =(celula *) malloc( sizeof(celula) ); //Reservando o espaćo na memória e fazendo com que o ponteiro NOVO tome conta do espaćo.
    novo->dado = 7; // Colocando um valor qualquer.
    novo->proximo = NULL; // Fazendo ele apontar para NADA, pois vai ser a última posićão da lista.
    inicio.proximo = novo; // Fazendo com que o inicio aponte para ele.


    //Aqui abaixo o mesmo processo de reservar um espaco na memória, e fazer com que o último elemento da lista aponte para este espaco criado.
    celula *novissimo =(celula *) malloc (sizeof(celula));
    novissimo->dado = 6;
    novissimo->proximo = inicio.proximo;
    inicio.proximo = novissimo;


    //Criando um auxiliar para poder percorrer a lista encadeada.
    celula *aux = &inicio; // comeca do início
    while(aux != NULL) //enquanto não chegar no fim
    {
        printf("[%d]", aux->dado); //mostra o dado
        aux = aux->proximo; // Pula para a próxima posicão apontada.
    }

    int numero = 6; //Escolhe um número para procurar.
    celula *procura; // variável auxiliar para percorrer a lista.
    procura = &inicio; //mesmo processo de percorrer utilizado no AUX, logo acima.
    while(procura->proximo != NULL)
    {
        if(procura->proximo->dado == numero) // Se achar o dado, dar um break. Assim o ponteiro "procura" apontará para o elemento que possui o dado pesquisado.
            break;
        procura = procura->proximo;
    }

    if(procura == NULL) // Se chegar neste ponto com procura valendo NULL, isso quer dizer que ele percorreu a lista inteira e não achou.
        printf("Não Achou!");
    else
    {
        printf("Achou [%d]", procura->proximo->dado);
        procura->proximo = procura->proximo->proximo; // Faz o processo de excluir o elemento da lista fazendo seu anterior apontar para o próximo.
    }




}









